%define pkgdir arc
Name: nordugrid-arc1
Version: 0.9.3
Release: 1%{?dist}
Summary: ARC
Group: System Environment/Daemons 
License: ASL 2.0
URL: http://www.nordugrid.org/
Source:	%{name}-%{version}.tar.gz
BuildRoot:%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
#
BuildRequires: cppunit-devel
BuildRequires: pkgconfig
BuildRequires: e2fsprogs-devel
BuildRequires: gcc-java
BuildRequires: gettext
BuildRequires: python
BuildRequires: python-devel
BuildRequires: glibmm24-devel
BuildRequires: glib2-devel
BuildRequires: libxml2-devel
BuildRequires: openssl-devel
BuildRequires: xmlsec1-devel >= 1.2.4
BuildRequires: xmlsec1-openssl-devel >= 1.2.4
BuildRequires: gsoap-devel >= 2.7.2
%if %{_vendor} == "suse"
BuildRequires: openldap2-devel
BuildRequires: gettext-devel
%endif
%if %{_vendor} != "suse"
BuildRequires: openldap-devel
%endif
#
BuildRequires: globus_common-devel
BuildRequires: globus_ftp_client-devel
BuildRequires: globus_ftp_control-devel
BuildRequires: globus_rls_client-devel
BuildRequires: globus_rsl-devel
#
BuildRequires: LFC-client-devel
#
%if %{_vendor} == "redhat"
BuildRequires: db4-devel
%endif
#%if %{_vendor} == "suse" && %{dist} != ".oss10.3"
#BuildRequires: db-devel
#%endif
#%if %{_vendor} == "suse" && %{dist} == ".oss10.3"
#BuildRequires: libdb_cxx-4_4-devel
#%endif
%if %{_vendor} == "suse"
BuildRequires: db-devel
%endif

%define pyver %(python -c 'import sys; print sys.version[:3]')
%if "%{pyver}" < "2.4"
%define ifpy #
%else
%define ifpy %{nil}
%endif

%description
ARC

%package client
Summary: ARC prototype clients
Group: Applications/Internet
Requires: %{name} = %{version}
Requires: %{name}-plugins-base = %{version}

%description client
ARC prototype clients.

%package server
Summary: ARC Hosting Environment Daemon
Group: System Environment/Libraries
Requires: %{name} = %{version}

%description server
ARC Hosting Environment Daemon (HED).

%package arex
Summary: ARC Remote EXecution service
Group: System Environment/Libraries
Requires: %{name} = %{version}
Requires: %{name}-server = %{version}
Requires: globus_common
Requires: globus_rsl
Requires: perl-XML-Simple

%description arex
ARC Remote EXecution service (AREX)

%package plugins-base
Summary: ARC base plugins
Group: System Environment/Libraries
Requires: %{name} = %{version}

%description plugins-base
ARC base plugins. This includes the Message Chain Components (MCCs) and
Data Manager Components (DMCs).

%package plugins-globus
Summary: ARC Globus plugins
Group: System Environment/Libraries
Requires: %{name} = %{version}
Requires: globus_common
Requires: globus_ftp_client
Requires: globus_ftp_control
Requires: globus_rls_client
Requires: LFC-client

%description plugins-globus
ARC Globus plugins. This includes the Globus dependent Data Manager
Components (DMCs):

  libdmcgridftp.so
  libdmclfc.so
  libdmcrls.so

%package devel
Summary: ARC development files
Group: Development/Libraries
Requires: %{name} = %{version}
Requires: glibmm24-devel
Requires: glib2-devel
Requires: libxml2-devel
Requires: openssl-devel

%description devel
Development files for ARC

%package python
Summary: ARC Python wrapper
Group: Development/Libraries
Requires: %{name} = %{version}
Requires: python

%description python
Python wrapper for ARC

%if "%{!?disable_java:java}"
%package java
Summary: ARC Java wrapper
Group: Development/Libraries
Requires: %{name} = %{version}

%description java
Java wrapper for ARC
%endif

%package doc
Summary: ARC API documentation
Group: Documentation

%description doc
ARC API docmentation

%prep
%setup -q

%build
%configure --disable-static %{?disable_java:--disable-java}
make all doc %{?_smp_mflags}
make check

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -type f -name \*.la -exec rm -fv '{}' ';'
mkdir -p $RPM_BUILD_ROOT/etc/init.d
cp -p src/hed/daemon/scripts/arched.redhat $RPM_BUILD_ROOT/etc/init.d/arched
chmod +x $RPM_BUILD_ROOT/etc/init.d/arched

# RPM does it's own doc handling
rm -fr $RPM_BUILD_ROOT%{_datadir}/doc/%{pkgdir}/

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post server
/sbin/chkconfig --add arched

%preun server
if [ $1 = 0 ]; then
  service arched stop > /dev/null 2>&1
  /sbin/chkconfig --del arched
fi

%postun server
if [ "$1" -ge "1" ]; then
  service arched condrestart > /dev/null 2>&1
fi
exit 0

%post arex
/sbin/chkconfig --add a-rex

%preun arex
if [ $1 = 0 ]; then
  service a-rex stop > /dev/null 2>&1
  /sbin/chkconfig --del a-rex
fi

%postun arex
if [ "$1" -ge "1" ]; then
  service a-rex condrestart > /dev/null 2>&1
fi
exit 0


%files
%defattr(-,root,root,-)
%doc ChangeLog README INSTALL AUTHORS LICENSE
%{_libdir}/lib*.so.*
%{_datadir}/locale/*/LC_MESSAGES/arc.mo

%files client
%defattr(-,root,root,-)
%doc src/clients/arclib/client.xml.example
%doc src/clients/charon/charon_client.xml.example
%doc src/clients/charon/charon_request.xml.example
%doc src/tests/echo/echo.wsdl
%{_bindir}/arcecho
%doc %{_mandir}/man1/arcecho.1*
%{_bindir}/arcsrmping
%doc %{_mandir}/man1/arcsrmping.1*
%{_bindir}/arcproxy
%doc %{_mandir}/man1/arcproxy.1*
%{_bindir}/arcslcs
%doc %{_mandir}/man1/arcslcs.1*
%{_bindir}/arccat
%doc %{_mandir}/man1/arccat.1*
%{_bindir}/arccp
%doc %{_mandir}/man1/arccp.1*
%{_bindir}/arcls
%doc %{_mandir}/man1/arcls.1*
%{_bindir}/arcrm
%doc %{_mandir}/man1/arcrm.1*
%{_bindir}/arcstat
%doc %{_mandir}/man1/arcstat.1*
%{_bindir}/arcinfo
%doc %{_mandir}/man1/arcinfo.1*
%{_bindir}/arcsub
%doc %{_mandir}/man1/arcsub.1*
%{_bindir}/arcsync
%doc %{_mandir}/man1/arcsync.1*
%{_bindir}/arcresub
%doc %{_mandir}/man1/arcresub.1*
%{_bindir}/arcget
%doc %{_mandir}/man1/arcget.1*
%{_bindir}/arcclean
%doc %{_mandir}/man1/arcclean.1*
%{_bindir}/arckill
%doc %{_mandir}/man1/arckill.1*
%{_bindir}/arcdecision
%doc %{_mandir}/man1/arcdecision.1*
%{_bindir}/arcmigrate
%doc %{_mandir}/man1/arcmigrate.1*
%{_bindir}/arcrenew
%doc %{_mandir}/man1/arcrenew.1*
%{_bindir}/arcresume
%doc %{_mandir}/man1/arcresume.1*
%{_bindir}/voms_assertion_init
%doc %{_mandir}/man1/voms_assertion_init.1*
%{_bindir}/perftest
%doc %{_mandir}/man1/perftest.1.gz
%{_bindir}/arc_storage_cli
%doc %{_mandir}/man1/arc_storage_cli.1*
%{_sysconfdir}/arcclient.xml
%doc %{_mandir}/man5/arcclient.xml.5*
%{_bindir}/arexlutsclient
%{_bindir}/arexlutsclient-wrapper.sh

%files server
%defattr(-,root,root,-)
/etc/init.d/arched
%{_sbindir}/arched
%doc %{_mandir}/man8/arched.8*
%{_sbindir}/manage_jobq
%doc %{_mandir}/man8/manage_jobq.8*
%doc src/services/charon/charon_policy.xml.example
%doc src/services/charon/charon_service.xml.example
%doc src/services/hopi/hopi_service.xml.example
%doc src/services/storage/storage_service.xml.example
%doc src/tests/echo/echo_service.xml.example
%{_libdir}/%{pkgdir}/libecho.so
%{_libdir}/%{pkgdir}/libcharon.so
%{_libdir}/%{pkgdir}/libhopi.so
%{_libdir}/%{pkgdir}/libisis.so
%{_libdir}/%{pkgdir}/libgrid_sched.so
%{_libdir}/%{pkgdir}/libpaul.so
%{_libdir}/%{pkgdir}/libslcs.so
%{_libdir}/%{pkgdir}/libcompiler.so
%{_libdir}/%{pkgdir}/libsaml2sp.so
%{_libdir}/%{pkgdir}/libdelegation.so

%files arex
%defattr(-,root,root,-)
/etc/init.d/a-rex
%doc src/services/a-rex/arex_service.xml.example
%doc src/services/a-rex/arex_minimalistic.xml.example
%doc src/services/a-rex/arex_service-secure.xml.example
%doc src/services/a-rex/arc_arex.conf
%doc %{_mandir}/man1/cache-clean.1*
%doc %{_mandir}/man1/cache-list.1*
%config(noreplace) %{_sysconfdir}/arc_arex.conf
%{_libdir}/%{pkgdir}/libarex.so
%{_libexecdir}/%{pkgdir}/downloader
%{_libexecdir}/%{pkgdir}/uploader
%{_libexecdir}/%{pkgdir}/smtp-send
%{_libexecdir}/%{pkgdir}/smtp-send.sh
%{_libexecdir}/%{pkgdir}/gm-kick
%{_libexecdir}/%{pkgdir}/cache-clean
%{_libexecdir}/%{pkgdir}/cache-list
#
%{_libdir}/%{pkgdir}/ARC0mod.pm
%{_libdir}/%{pkgdir}/FORKmod.pm
%{_libdir}/%{pkgdir}/SGEmod.pm
%{_libdir}/%{pkgdir}/LL.pm
%{_libdir}/%{pkgdir}/LSF.pm
%{_libdir}/%{pkgdir}/PBS.pm
%{_libdir}/%{pkgdir}/Condor.pm
%{_libdir}/%{pkgdir}/SLURM.pm
#
%{_libdir}/%{pkgdir}/ARC0ClusterInfo.pm
%{_libdir}/%{pkgdir}/ARC0ClusterSchema.pm
%{_libdir}/%{pkgdir}/ARC1ClusterInfo.pm
%{_libdir}/%{pkgdir}/ARC1ClusterSchema.pm
%{_libdir}/%{pkgdir}/ConfigParser.pm
%{_libdir}/%{pkgdir}/GMJobsInfo.pm
%{_libdir}/%{pkgdir}/HostInfo.pm
%{_libdir}/%{pkgdir}/InfoChecker.pm
%{_libdir}/%{pkgdir}/InfoCollector.pm
%{_libdir}/%{pkgdir}/LRMSInfo.pm
#
%{_libdir}/%{pkgdir}/LogUtils.pm
%{_libdir}/%{pkgdir}/Sysinfo.pm
#
%{_libexecdir}/%{pkgdir}/submit-*-job
%{_libexecdir}/%{pkgdir}/cancel-*-job
%{_libexecdir}/%{pkgdir}/scan-*-job
%{_libdir}/%{pkgdir}/configure-*-env.sh
#
%{_libdir}/%{pkgdir}/submit_common.sh
%{_libdir}/%{pkgdir}/cancel_common.sh
%{_libdir}/%{pkgdir}/config_parser.sh
#
%{_libdir}/%{pkgdir}/condor_env.pm
%{_libdir}/%{pkgdir}/change-lsf-mode.sh
%{_libexecdir}/%{pkgdir}/finish-condor-job
#
%{_libexecdir}/%{pkgdir}/CEinfo.pl
%{_datadir}/%{pkgdir}/nordugrid.schema

%files devel
%defattr(-,root,root,-)
%{_includedir}/%{pkgdir}
#%{_libdir}/lib*.a
#%{_libdir}/lib*.la
%{_libdir}/lib*.so
%{_bindir}/wsdl2hed
%doc %{_mandir}/man1/wsdl2hed.1*

%files plugins-base
%defattr(-,root,root,-)
%{_libdir}/%{pkgdir}/libmcchttp.so
%{_libdir}/%{pkgdir}/libmccmsgvalidator.so
%{_libdir}/%{pkgdir}/libmccsoap.so
%{_libdir}/%{pkgdir}/libmcctcp.so
%{_libdir}/%{pkgdir}/libmcctls.so
%{_libdir}/%{pkgdir}/libdmcfile.so
%{_libdir}/%{pkgdir}/libdmchttp.so
%{_libdir}/%{pkgdir}/libdmcarc.so
%{_libdir}/%{pkgdir}/libdmcldap.so
%{_libdir}/%{pkgdir}/libarcshc.so
%{_libdir}/%{pkgdir}/libidentitymap.so
%{_libdir}/%{pkgdir}/libaccARC1.so
%{_libdir}/%{pkgdir}/libaccCREAM.so
%{_libdir}/%{pkgdir}/libaccBroker.so
%{_libdir}/%{pkgdir}/libaccUNICORE.so

%files plugins-globus
%defattr(-,root,root,-)
%{_libdir}/%{pkgdir}/libmccgsi.so
%{_libdir}/%{pkgdir}/libdmcgridftp.so
%{_libdir}/%{pkgdir}/libdmclfc.so
%{_libdir}/%{pkgdir}/libdmcrls.so
%{_libdir}/%{pkgdir}/libdmcsrm.so
%{_libdir}/%{pkgdir}/libaccARC0.so

%files python
%defattr(-,root,root,-)
%{_libdir}/python?.?/site-packages/
%{ifpy}%{_libdir}/%{pkgdir}/libpythonservice.so
%{ifpy}%{_libdir}/%{pkgdir}/libaccPythonBroker.so
%{ifpy}%doc src/hed/acc/PythonBroker/SampleBroker.py

%if "%{!?disable_java:java}"
%files java
%defattr(-,root,root,-)
%{_libdir}/java/libjarc.so
%{_datadir}/java/arc.jar
%{_libdir}/%{pkgdir}/libjavaservice.so
%endif

%files doc
%defattr(-,root,root,-)
#%doc doc/tech_doc/doxygen/ARC1-*.pdf

%changelog

* Fri Jul 27 2007 Anders Waananen <waananen@nbi.dk> - 1.0-1
- Initial release

